# coding: utf-8

"""
    API League

    API League is a Hub for World Class APIs.

    The version of the OpenAPI document: 1.6.4
    Contact: mail@apileague.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictBool, field_validator
from typing import Optional, Union
from typing_extensions import Annotated
from apileague.models.extract_news_api200_response import ExtractNewsAPI200Response
from apileague.models.search_news_api200_response import SearchNewsAPI200Response
from apileague.models.top_news_api200_response import TopNewsAPI200Response

from apileague.api_client import ApiClient, RequestSerialized
from apileague.api_response import ApiResponse
from apileague.rest import RESTResponseType


class NewsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def extract_news_api(
        self,
        url: Annotated[str, Field(strict=True, max_length=1000, description="The url of the news.")],
        analyze: Annotated[StrictBool, Field(description="Whether to analyze the news (extract entities etc.)")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ExtractNewsAPI200Response:
        """Extract News API

        Extract a news article from a website to a well structure JSON object. The API will return the title, text, URL, image, publish date, author, language, source country, and sentiment of the news article.

        :param url: The url of the news. (required)
        :type url: str
        :param analyze: Whether to analyze the news (extract entities etc.) (required)
        :type analyze: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._extract_news_api_serialize(
            url=url,
            analyze=analyze,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ExtractNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def extract_news_api_with_http_info(
        self,
        url: Annotated[str, Field(strict=True, max_length=1000, description="The url of the news.")],
        analyze: Annotated[StrictBool, Field(description="Whether to analyze the news (extract entities etc.)")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[ExtractNewsAPI200Response]:
        """Extract News API

        Extract a news article from a website to a well structure JSON object. The API will return the title, text, URL, image, publish date, author, language, source country, and sentiment of the news article.

        :param url: The url of the news. (required)
        :type url: str
        :param analyze: Whether to analyze the news (extract entities etc.) (required)
        :type analyze: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._extract_news_api_serialize(
            url=url,
            analyze=analyze,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ExtractNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def extract_news_api_without_preload_content(
        self,
        url: Annotated[str, Field(strict=True, max_length=1000, description="The url of the news.")],
        analyze: Annotated[StrictBool, Field(description="Whether to analyze the news (extract entities etc.)")],
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Extract News API

        Extract a news article from a website to a well structure JSON object. The API will return the title, text, URL, image, publish date, author, language, source country, and sentiment of the news article.

        :param url: The url of the news. (required)
        :type url: str
        :param analyze: Whether to analyze the news (extract entities etc.) (required)
        :type analyze: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._extract_news_api_serialize(
            url=url,
            analyze=analyze,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "ExtractNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _extract_news_api_serialize(
        self,
        url,
        analyze,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if url is not None:
            
            _query_params.append(('url', url))
            
        if analyze is not None:
            
            _query_params.append(('analyze', analyze))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'apiKey', 
            'headerApiKey'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/extract-news',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def search_news_api(
        self,
        text: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The text to match in the news content (at least 3 characters, maximum 100 characters). By default all query terms are expected, you can use an uppercase OR to search for any terms, e.g. tesla OR ford. You can also exclude terms by putting a minus sign (-) in front of the term, e.g. tesla -ford.")] = None,
        source_countries: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="A comma-separated list of ISO 3166 country codes from which the news should originate.")] = None,
        language: Annotated[Optional[Annotated[str, Field(strict=True, max_length=2)]], Field(description="The ISO 6391 language code of the news.")] = None,
        min_sentiment: Annotated[Optional[Union[Annotated[float, Field(le=1, strict=True, ge=-1)], Annotated[int, Field(le=1, strict=True, ge=-1)]]], Field(description="The minimal sentiment of the news in range [-1,1].")] = None,
        max_sentiment: Annotated[Optional[Union[Annotated[float, Field(le=1, strict=True, ge=-1)], Annotated[int, Field(le=1, strict=True, ge=-1)]]], Field(description="The maximal sentiment of the news in range [-1,1].")] = None,
        earliest_publish_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The news must have been published after this date.")] = None,
        latest_publish_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The news must have been published before this date.")] = None,
        news_sources: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10000)]], Field(description="A comma-separated list of news sources from which the news should originate.")] = None,
        authors: Annotated[Optional[Annotated[str, Field(strict=True, max_length=300)]], Field(description="A comma-separated list of author names. Only news from any of the given authors will be returned.")] = None,
        categories: Annotated[Optional[Annotated[str, Field(strict=True, max_length=300)]], Field(description="A comma-separated list of categories. Only news from any of the given categories will be returned. Possible categories are politics, sports, business, technology, entertainment, health, science, lifestyle, travel, culture, education, environment, other.")] = None,
        entities: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10000)]], Field(description="Filter news by entities (ORG, PER, or LOC).")] = None,
        location_filter: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="Filter news by radius around a certain location. Format is \"latitude,longitude,radius in kilometers\"")] = None,
        sort: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The sorting criteria (publish-time).")] = None,
        sort_direction: Annotated[Optional[Annotated[str, Field(strict=True, max_length=4)]], Field(description="Whether to sort ascending or descending (ASC or DESC).")] = None,
        offset: Annotated[Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]], Field(description="The number of news to skip in range [0,10000]")] = None,
        number: Annotated[Optional[Annotated[int, Field(le=100, strict=True, ge=1)]], Field(description="The number of news to return in range [1,100]")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> SearchNewsAPI200Response:
        """Search News API

        Search and filter millions of news from over 200 countries in 90 languages by text, date, location, category, language, and more. The API returns a list of news articles matching the given criteria. You can set as many filtering parameters as you like, but you have to set at least one, e.g. text or language.

        :param text: The text to match in the news content (at least 3 characters, maximum 100 characters). By default all query terms are expected, you can use an uppercase OR to search for any terms, e.g. tesla OR ford. You can also exclude terms by putting a minus sign (-) in front of the term, e.g. tesla -ford.
        :type text: str
        :param source_countries: A comma-separated list of ISO 3166 country codes from which the news should originate.
        :type source_countries: str
        :param language: The ISO 6391 language code of the news.
        :type language: str
        :param min_sentiment: The minimal sentiment of the news in range [-1,1].
        :type min_sentiment: float
        :param max_sentiment: The maximal sentiment of the news in range [-1,1].
        :type max_sentiment: float
        :param earliest_publish_date: The news must have been published after this date.
        :type earliest_publish_date: str
        :param latest_publish_date: The news must have been published before this date.
        :type latest_publish_date: str
        :param news_sources: A comma-separated list of news sources from which the news should originate.
        :type news_sources: str
        :param authors: A comma-separated list of author names. Only news from any of the given authors will be returned.
        :type authors: str
        :param categories: A comma-separated list of categories. Only news from any of the given categories will be returned. Possible categories are politics, sports, business, technology, entertainment, health, science, lifestyle, travel, culture, education, environment, other.
        :type categories: str
        :param entities: Filter news by entities (ORG, PER, or LOC).
        :type entities: str
        :param location_filter: Filter news by radius around a certain location. Format is \"latitude,longitude,radius in kilometers\"
        :type location_filter: str
        :param sort: The sorting criteria (publish-time).
        :type sort: str
        :param sort_direction: Whether to sort ascending or descending (ASC or DESC).
        :type sort_direction: str
        :param offset: The number of news to skip in range [0,10000]
        :type offset: int
        :param number: The number of news to return in range [1,100]
        :type number: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._search_news_api_serialize(
            text=text,
            source_countries=source_countries,
            language=language,
            min_sentiment=min_sentiment,
            max_sentiment=max_sentiment,
            earliest_publish_date=earliest_publish_date,
            latest_publish_date=latest_publish_date,
            news_sources=news_sources,
            authors=authors,
            categories=categories,
            entities=entities,
            location_filter=location_filter,
            sort=sort,
            sort_direction=sort_direction,
            offset=offset,
            number=number,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "SearchNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def search_news_api_with_http_info(
        self,
        text: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The text to match in the news content (at least 3 characters, maximum 100 characters). By default all query terms are expected, you can use an uppercase OR to search for any terms, e.g. tesla OR ford. You can also exclude terms by putting a minus sign (-) in front of the term, e.g. tesla -ford.")] = None,
        source_countries: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="A comma-separated list of ISO 3166 country codes from which the news should originate.")] = None,
        language: Annotated[Optional[Annotated[str, Field(strict=True, max_length=2)]], Field(description="The ISO 6391 language code of the news.")] = None,
        min_sentiment: Annotated[Optional[Union[Annotated[float, Field(le=1, strict=True, ge=-1)], Annotated[int, Field(le=1, strict=True, ge=-1)]]], Field(description="The minimal sentiment of the news in range [-1,1].")] = None,
        max_sentiment: Annotated[Optional[Union[Annotated[float, Field(le=1, strict=True, ge=-1)], Annotated[int, Field(le=1, strict=True, ge=-1)]]], Field(description="The maximal sentiment of the news in range [-1,1].")] = None,
        earliest_publish_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The news must have been published after this date.")] = None,
        latest_publish_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The news must have been published before this date.")] = None,
        news_sources: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10000)]], Field(description="A comma-separated list of news sources from which the news should originate.")] = None,
        authors: Annotated[Optional[Annotated[str, Field(strict=True, max_length=300)]], Field(description="A comma-separated list of author names. Only news from any of the given authors will be returned.")] = None,
        categories: Annotated[Optional[Annotated[str, Field(strict=True, max_length=300)]], Field(description="A comma-separated list of categories. Only news from any of the given categories will be returned. Possible categories are politics, sports, business, technology, entertainment, health, science, lifestyle, travel, culture, education, environment, other.")] = None,
        entities: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10000)]], Field(description="Filter news by entities (ORG, PER, or LOC).")] = None,
        location_filter: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="Filter news by radius around a certain location. Format is \"latitude,longitude,radius in kilometers\"")] = None,
        sort: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The sorting criteria (publish-time).")] = None,
        sort_direction: Annotated[Optional[Annotated[str, Field(strict=True, max_length=4)]], Field(description="Whether to sort ascending or descending (ASC or DESC).")] = None,
        offset: Annotated[Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]], Field(description="The number of news to skip in range [0,10000]")] = None,
        number: Annotated[Optional[Annotated[int, Field(le=100, strict=True, ge=1)]], Field(description="The number of news to return in range [1,100]")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[SearchNewsAPI200Response]:
        """Search News API

        Search and filter millions of news from over 200 countries in 90 languages by text, date, location, category, language, and more. The API returns a list of news articles matching the given criteria. You can set as many filtering parameters as you like, but you have to set at least one, e.g. text or language.

        :param text: The text to match in the news content (at least 3 characters, maximum 100 characters). By default all query terms are expected, you can use an uppercase OR to search for any terms, e.g. tesla OR ford. You can also exclude terms by putting a minus sign (-) in front of the term, e.g. tesla -ford.
        :type text: str
        :param source_countries: A comma-separated list of ISO 3166 country codes from which the news should originate.
        :type source_countries: str
        :param language: The ISO 6391 language code of the news.
        :type language: str
        :param min_sentiment: The minimal sentiment of the news in range [-1,1].
        :type min_sentiment: float
        :param max_sentiment: The maximal sentiment of the news in range [-1,1].
        :type max_sentiment: float
        :param earliest_publish_date: The news must have been published after this date.
        :type earliest_publish_date: str
        :param latest_publish_date: The news must have been published before this date.
        :type latest_publish_date: str
        :param news_sources: A comma-separated list of news sources from which the news should originate.
        :type news_sources: str
        :param authors: A comma-separated list of author names. Only news from any of the given authors will be returned.
        :type authors: str
        :param categories: A comma-separated list of categories. Only news from any of the given categories will be returned. Possible categories are politics, sports, business, technology, entertainment, health, science, lifestyle, travel, culture, education, environment, other.
        :type categories: str
        :param entities: Filter news by entities (ORG, PER, or LOC).
        :type entities: str
        :param location_filter: Filter news by radius around a certain location. Format is \"latitude,longitude,radius in kilometers\"
        :type location_filter: str
        :param sort: The sorting criteria (publish-time).
        :type sort: str
        :param sort_direction: Whether to sort ascending or descending (ASC or DESC).
        :type sort_direction: str
        :param offset: The number of news to skip in range [0,10000]
        :type offset: int
        :param number: The number of news to return in range [1,100]
        :type number: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._search_news_api_serialize(
            text=text,
            source_countries=source_countries,
            language=language,
            min_sentiment=min_sentiment,
            max_sentiment=max_sentiment,
            earliest_publish_date=earliest_publish_date,
            latest_publish_date=latest_publish_date,
            news_sources=news_sources,
            authors=authors,
            categories=categories,
            entities=entities,
            location_filter=location_filter,
            sort=sort,
            sort_direction=sort_direction,
            offset=offset,
            number=number,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "SearchNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def search_news_api_without_preload_content(
        self,
        text: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The text to match in the news content (at least 3 characters, maximum 100 characters). By default all query terms are expected, you can use an uppercase OR to search for any terms, e.g. tesla OR ford. You can also exclude terms by putting a minus sign (-) in front of the term, e.g. tesla -ford.")] = None,
        source_countries: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="A comma-separated list of ISO 3166 country codes from which the news should originate.")] = None,
        language: Annotated[Optional[Annotated[str, Field(strict=True, max_length=2)]], Field(description="The ISO 6391 language code of the news.")] = None,
        min_sentiment: Annotated[Optional[Union[Annotated[float, Field(le=1, strict=True, ge=-1)], Annotated[int, Field(le=1, strict=True, ge=-1)]]], Field(description="The minimal sentiment of the news in range [-1,1].")] = None,
        max_sentiment: Annotated[Optional[Union[Annotated[float, Field(le=1, strict=True, ge=-1)], Annotated[int, Field(le=1, strict=True, ge=-1)]]], Field(description="The maximal sentiment of the news in range [-1,1].")] = None,
        earliest_publish_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The news must have been published after this date.")] = None,
        latest_publish_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The news must have been published before this date.")] = None,
        news_sources: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10000)]], Field(description="A comma-separated list of news sources from which the news should originate.")] = None,
        authors: Annotated[Optional[Annotated[str, Field(strict=True, max_length=300)]], Field(description="A comma-separated list of author names. Only news from any of the given authors will be returned.")] = None,
        categories: Annotated[Optional[Annotated[str, Field(strict=True, max_length=300)]], Field(description="A comma-separated list of categories. Only news from any of the given categories will be returned. Possible categories are politics, sports, business, technology, entertainment, health, science, lifestyle, travel, culture, education, environment, other.")] = None,
        entities: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10000)]], Field(description="Filter news by entities (ORG, PER, or LOC).")] = None,
        location_filter: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="Filter news by radius around a certain location. Format is \"latitude,longitude,radius in kilometers\"")] = None,
        sort: Annotated[Optional[Annotated[str, Field(strict=True, max_length=100)]], Field(description="The sorting criteria (publish-time).")] = None,
        sort_direction: Annotated[Optional[Annotated[str, Field(strict=True, max_length=4)]], Field(description="Whether to sort ascending or descending (ASC or DESC).")] = None,
        offset: Annotated[Optional[Annotated[int, Field(le=10000, strict=True, ge=0)]], Field(description="The number of news to skip in range [0,10000]")] = None,
        number: Annotated[Optional[Annotated[int, Field(le=100, strict=True, ge=1)]], Field(description="The number of news to return in range [1,100]")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Search News API

        Search and filter millions of news from over 200 countries in 90 languages by text, date, location, category, language, and more. The API returns a list of news articles matching the given criteria. You can set as many filtering parameters as you like, but you have to set at least one, e.g. text or language.

        :param text: The text to match in the news content (at least 3 characters, maximum 100 characters). By default all query terms are expected, you can use an uppercase OR to search for any terms, e.g. tesla OR ford. You can also exclude terms by putting a minus sign (-) in front of the term, e.g. tesla -ford.
        :type text: str
        :param source_countries: A comma-separated list of ISO 3166 country codes from which the news should originate.
        :type source_countries: str
        :param language: The ISO 6391 language code of the news.
        :type language: str
        :param min_sentiment: The minimal sentiment of the news in range [-1,1].
        :type min_sentiment: float
        :param max_sentiment: The maximal sentiment of the news in range [-1,1].
        :type max_sentiment: float
        :param earliest_publish_date: The news must have been published after this date.
        :type earliest_publish_date: str
        :param latest_publish_date: The news must have been published before this date.
        :type latest_publish_date: str
        :param news_sources: A comma-separated list of news sources from which the news should originate.
        :type news_sources: str
        :param authors: A comma-separated list of author names. Only news from any of the given authors will be returned.
        :type authors: str
        :param categories: A comma-separated list of categories. Only news from any of the given categories will be returned. Possible categories are politics, sports, business, technology, entertainment, health, science, lifestyle, travel, culture, education, environment, other.
        :type categories: str
        :param entities: Filter news by entities (ORG, PER, or LOC).
        :type entities: str
        :param location_filter: Filter news by radius around a certain location. Format is \"latitude,longitude,radius in kilometers\"
        :type location_filter: str
        :param sort: The sorting criteria (publish-time).
        :type sort: str
        :param sort_direction: Whether to sort ascending or descending (ASC or DESC).
        :type sort_direction: str
        :param offset: The number of news to skip in range [0,10000]
        :type offset: int
        :param number: The number of news to return in range [1,100]
        :type number: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._search_news_api_serialize(
            text=text,
            source_countries=source_countries,
            language=language,
            min_sentiment=min_sentiment,
            max_sentiment=max_sentiment,
            earliest_publish_date=earliest_publish_date,
            latest_publish_date=latest_publish_date,
            news_sources=news_sources,
            authors=authors,
            categories=categories,
            entities=entities,
            location_filter=location_filter,
            sort=sort,
            sort_direction=sort_direction,
            offset=offset,
            number=number,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "SearchNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _search_news_api_serialize(
        self,
        text,
        source_countries,
        language,
        min_sentiment,
        max_sentiment,
        earliest_publish_date,
        latest_publish_date,
        news_sources,
        authors,
        categories,
        entities,
        location_filter,
        sort,
        sort_direction,
        offset,
        number,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if text is not None:
            
            _query_params.append(('text', text))
            
        if source_countries is not None:
            
            _query_params.append(('source-countries', source_countries))
            
        if language is not None:
            
            _query_params.append(('language', language))
            
        if min_sentiment is not None:
            
            _query_params.append(('min-sentiment', min_sentiment))
            
        if max_sentiment is not None:
            
            _query_params.append(('max-sentiment', max_sentiment))
            
        if earliest_publish_date is not None:
            
            _query_params.append(('earliest-publish-date', earliest_publish_date))
            
        if latest_publish_date is not None:
            
            _query_params.append(('latest-publish-date', latest_publish_date))
            
        if news_sources is not None:
            
            _query_params.append(('news-sources', news_sources))
            
        if authors is not None:
            
            _query_params.append(('authors', authors))
            
        if categories is not None:
            
            _query_params.append(('categories', categories))
            
        if entities is not None:
            
            _query_params.append(('entities', entities))
            
        if location_filter is not None:
            
            _query_params.append(('location-filter', location_filter))
            
        if sort is not None:
            
            _query_params.append(('sort', sort))
            
        if sort_direction is not None:
            
            _query_params.append(('sort-direction', sort_direction))
            
        if offset is not None:
            
            _query_params.append(('offset', offset))
            
        if number is not None:
            
            _query_params.append(('number', number))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'apiKey', 
            'headerApiKey'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/search-news',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def top_news_api(
        self,
        source_country: Annotated[str, Field(strict=True, max_length=2, description="The ISO 3166 country code of the country for which top news should be retrieved.")],
        language: Annotated[str, Field(strict=True, max_length=2, description="The ISO 6391 language code of the top news. The language must be one spoken in the source-country.")],
        var_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10)]], Field(description="The date for which the top news should be retrieved. If no date is given, the current day is assumed.")] = None,
        headlines_only: Annotated[Optional[StrictBool], Field(description="Whether to only return basic information such as id, title, and url of the news.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> TopNewsAPI200Response:
        """Top News API

        Get the top news from a country (over 220 are supported) in a language (over 90 are supported) for a specific date. The top news are clustered from multiple sources in the given country. The more news in a cluster the higher the cluster is ranked.

        :param source_country: The ISO 3166 country code of the country for which top news should be retrieved. (required)
        :type source_country: str
        :param language: The ISO 6391 language code of the top news. The language must be one spoken in the source-country. (required)
        :type language: str
        :param var_date: The date for which the top news should be retrieved. If no date is given, the current day is assumed.
        :type var_date: str
        :param headlines_only: Whether to only return basic information such as id, title, and url of the news.
        :type headlines_only: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._top_news_api_serialize(
            source_country=source_country,
            language=language,
            var_date=var_date,
            headlines_only=headlines_only,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "TopNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def top_news_api_with_http_info(
        self,
        source_country: Annotated[str, Field(strict=True, max_length=2, description="The ISO 3166 country code of the country for which top news should be retrieved.")],
        language: Annotated[str, Field(strict=True, max_length=2, description="The ISO 6391 language code of the top news. The language must be one spoken in the source-country.")],
        var_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10)]], Field(description="The date for which the top news should be retrieved. If no date is given, the current day is assumed.")] = None,
        headlines_only: Annotated[Optional[StrictBool], Field(description="Whether to only return basic information such as id, title, and url of the news.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[TopNewsAPI200Response]:
        """Top News API

        Get the top news from a country (over 220 are supported) in a language (over 90 are supported) for a specific date. The top news are clustered from multiple sources in the given country. The more news in a cluster the higher the cluster is ranked.

        :param source_country: The ISO 3166 country code of the country for which top news should be retrieved. (required)
        :type source_country: str
        :param language: The ISO 6391 language code of the top news. The language must be one spoken in the source-country. (required)
        :type language: str
        :param var_date: The date for which the top news should be retrieved. If no date is given, the current day is assumed.
        :type var_date: str
        :param headlines_only: Whether to only return basic information such as id, title, and url of the news.
        :type headlines_only: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._top_news_api_serialize(
            source_country=source_country,
            language=language,
            var_date=var_date,
            headlines_only=headlines_only,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "TopNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def top_news_api_without_preload_content(
        self,
        source_country: Annotated[str, Field(strict=True, max_length=2, description="The ISO 3166 country code of the country for which top news should be retrieved.")],
        language: Annotated[str, Field(strict=True, max_length=2, description="The ISO 6391 language code of the top news. The language must be one spoken in the source-country.")],
        var_date: Annotated[Optional[Annotated[str, Field(strict=True, max_length=10)]], Field(description="The date for which the top news should be retrieved. If no date is given, the current day is assumed.")] = None,
        headlines_only: Annotated[Optional[StrictBool], Field(description="Whether to only return basic information such as id, title, and url of the news.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Top News API

        Get the top news from a country (over 220 are supported) in a language (over 90 are supported) for a specific date. The top news are clustered from multiple sources in the given country. The more news in a cluster the higher the cluster is ranked.

        :param source_country: The ISO 3166 country code of the country for which top news should be retrieved. (required)
        :type source_country: str
        :param language: The ISO 6391 language code of the top news. The language must be one spoken in the source-country. (required)
        :type language: str
        :param var_date: The date for which the top news should be retrieved. If no date is given, the current day is assumed.
        :type var_date: str
        :param headlines_only: Whether to only return basic information such as id, title, and url of the news.
        :type headlines_only: bool
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._top_news_api_serialize(
            source_country=source_country,
            language=language,
            var_date=var_date,
            headlines_only=headlines_only,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "TopNewsAPI200Response",
            '401': None,
            '402': None,
            '403': None,
            '404': None,
            '406': None,
            '429': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _top_news_api_serialize(
        self,
        source_country,
        language,
        var_date,
        headlines_only,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if source_country is not None:
            
            _query_params.append(('source-country', source_country))
            
        if language is not None:
            
            _query_params.append(('language', language))
            
        if var_date is not None:
            
            _query_params.append(('date', var_date))
            
        if headlines_only is not None:
            
            _query_params.append(('headlines-only', headlines_only))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'apiKey', 
            'headerApiKey'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/retrieve-top-news',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


